unit fHashValueComparison;

interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.StdCtrls;

type
  TfrmHashValueComparison = class(TForm)
    lblHashValue1: TLabel;
    lblHashValue2: TLabel;
    edtHashValue1: TEdit;
    edtHashValue2: TEdit;
    btnOK: TButton;
    btnCompare: TButton;
    procedure btnCompareClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmHashValueComparison: TfrmHashValueComparison;

procedure CompareHashValues(aHashValue1: string; aHashValue2: string = '');

implementation

{$R *.dfm}


procedure CompareHashValues(aHashValue1: string; aHashValue2: string = '');
begin
  with TfrmHashValueComparison.Create(Application) do
    try
      edtHashValue1.Text := aHashValue1;
      edtHashValue2.Text := aHashValue2;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TfrmHashValueComparison.btnCompareClick(Sender: TObject);
var
  aHash1, aHash2: string;

  procedure FindMismatch(aString1, aString2: string);
  var
    i: integer;
  begin
    // Get the strings to equal length
    if Length(aString1) < Length(aString2) then
      aString1 := Format('%-*s', [Length(aString2), aString1])
    else if Length(aString2) < Length(aString1) then
      aString2 := Format('%-*s', [Length(aString1), aString2]);

    //ShowMessage('String1: >' + aString1 + '<#13#10String2: >' + aString2 + '<');

    for i := 1 to Length(aHash1) do
      if Copy(aHash2, i, 1) <> Copy(aHash1, i, 1) then
        begin
          ShowMessageFmt('Mismatch found at position %d' + #13#10 + '%s' + #13#10 + '%s', [i, Copy(aHash1, 1, i), Copy(aHash2, 1, i)]);
          Break;
        end;
  end;

begin
  aHash1 := edtHashValue1.Text;
  aHash2 := edtHashValue2.Text;

  if AnsiCompareStr(aHash1, aHash2) = 0 then
    MessageDlg('Hash Values Match', mtinformation, [mbOk], 0)
  else
    FindMismatch(aHash1, aHash2);
end;

end.
